
-- [turtlesort.com, 2012]

-- Provides utility functions for UTF-8
-- encoded strings.

local utf8 = {}


-- Determines length for utf-8 encoded
-- strings with characters up to 2 bytes
-- in length.
function utf8.len2(str)

	local bytes = string.len(str)
	local length = 0
	
	local i = 1
	while i <= bytes do
	
		length = length + 1	

		if string.byte(str,i) > 127 then
			i = i + 1
		end
	
		i = i + 1
	
	end
	
	return length

end

-- A substring function for utf-8 encoded
-- strings with characters up to 2 bytes
-- in length.
function utf8.sub2(str,s,l)

	local bytes = string.len(str)

	local i = 1
	while i <= bytes do
		
		local c = string.byte(str,i)
	
		if c > 127 then -- 2 byte character detected
			
			-- the starting index needs to be moved by one
			if i < s then
				s = s + 1
			end
			
			
			i = i + 1 -- no need to check next byte
			l = l + 1 -- the ending index needs to be moved by one
			
		end
		
		i = i + 1
		
		if i > l then
			break
		end
		
	end
	
	return string.sub(str,s,l)

end

return utf8